
Core - Epic # 47018

Status: Resolved Priority: Could have
Author: Thomas Maroschik Category:
Created: 2013-04-07 Assigned To: Thomas Maroschik
Updated: 2015-05-19 Due date:
Sprint Focus:
Subject: Implement Composer support and clean package manager API
Description

Subtasks:
Task # 52737: Integrate Flow Package Subpackage Resolved
Task # 52740: Add composer.json files Resolved
Bug # 55908: Package-Manager / Extension-Manager reads depencies only from ext_emconf.php Resolved
Bug # 55905: In some matter the package manager duplicates entries in PackageState whic... Closed
Bug # 55755: Legacy packages with dependencies to other composer packages coudn't be in... Rejected
Task # 55749: isPackageActive() should check runtimeActivatedPackages first Resolved
Bug # 55646: Framework Packages aren't sorted properly if package is overriten in typo3... Needs Feedback
Bug # 53537: PackageFactory class not found while running install-tool in 6.2 Closed
Bug # 55152: Class 'TYPO3\Flow\Package\Exception\InvalidPackageStateException' not found Closed
Bug # 53342: PackageManager::getCacheIdentifier() uses truncated md5 Resolved
Bug # 54581: Please repair PackageStates before next Beta! Closed
Bug # 53459: Extension manager - removed extension stays in PackageStates.php as inactive Resolved
Bug # 54491: PackageManager doesn't solve/recognize real composer packages  Under Review
Task # 53122: Use package manager in impexp extension selector Closed
Bug # 52984: PackageManager resolving dependencies uses folderstructure for building keys Rejected
Bug # 55413: [Extension Manager] - PackageStates.php empty if incompatible extension is... Closed
Feature # 51473: Make it possible, that extensions use composer to load libraries just ... Resolved
Task # 55404: Extract package dependency sorting to own class Resolved
Feature # 53015: Allow the activation of packages during runtime Resolved
Task # 53886: Optimize Package State Migration Resolved
Related issues:
related to Core - Bug # 53478: Performance: remove unneeded basename call in ... Resolved 2013-11-09
related to Core - Feature # 46615: Speed improvements in ClassLoader Closed 2013-03-23
related to Core - Task # 52731: Use 6.1 branch in travis-integration for travis Resolved 2013-10-12
related to Core - Bug # 55517: ClassLoader not working with NullBackend for l... Resolved 2014-01-31
related to Core - Bug # 55555: Cleanup EXT/requiredExt handling Resolved 2014-02-01
related to Core - Bug # 52891: Fatal error in ExtensionCompatibilityTester Closed 2013-10-16
precedes Core - Bug # 54857: Test extensions are not considered in functional... Resolved 2014-01-09

Associated revisions
Revision f4f27565 - 2013-10-12 22:22 - Christian Kuhn

[TASK] Use 6.1 branch in travis-integration for travis

Change-Id: I748bae0a4c4995d6e47b42d2d84cead36db3665d
Resolves: #52731
Related: #47018
Releases: 6.1, 6.0
Reviewed-on: https://review.typo3.org/24660
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Revision f272d549 - 2013-10-12 22:41 - Christian Kuhn

[TASK] Use 6.1 branch in travis-integration for travis

Change-Id: I748bae0a4c4995d6e47b42d2d84cead36db3665d
Resolves: #52731
Related: #47018
Releases: 6.1, 6.0
Reviewed-on: https://review.typo3.org/24660
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
(cherry picked from commit f4f2756533761fa2da2d89f6f91e2be90c2dcb42)
Reviewed-on: https://review.typo3.org/24662

Revision 16ac878e - 2013-10-13 02:12 - Christian Kuhn

[TASK] Add composer.json files for each sysext extension

Change-Id: Iaf88fc46903400d97f6f1dc3acedb3c9b438e8dd
Releases: 6.2
Resolves: #52740
Related: #47018
Reviewed-on: https://review.typo3.org/24667
Reviewed-by: Thomas Maroschik
Tested-by: Thomas Maroschik
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision 04cca5ff - 2013-10-13 02:37 - Thomas Maroschik

[TASK] Integrate Flow Package Subpackage

In order to enable the Package Management API, the used Flow classes
have been placed in the core. The last synced state and the made
changes to the source are noted in a README file.

Resolves: #52737
Related: #47018
Releases: 6.2
Change-Id: Ic8fda623d9ff81f52c3c104a0d5ae7c290bf7953
Reviewed-on: https://review.typo3.org/24666
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Sascha Egerer
Tested-by: Sascha Egerer
Reviewed-by: Thomas Maroschik
Tested-by: Thomas Maroschik

2015-08-04 2/8

https://review.typo3.org/24660
https://review.typo3.org/24662
https://review.typo3.org/24667
https://review.typo3.org/24666


Revision 84d6207c - 2013-10-13 14:48 - Thomas Maroschik

[FEATURE] Integrate preliminary PackageManager API

The Package Manager from Flow has been backported and integrated as
CMS Package Manager. This enables us to use full vendor namespaces for
extensions and brings us closer to a unified TYPO3 package format.

For more Details see: http://wiki.typo3.org/Blueprints/Packagemanager

Resolves: #47018
Releases: 6.2
Change-Id: I52abedaf470cebddb3553e37581021bf368380e6
Reviewed-on: https://review.typo3.org/19605
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Reviewed-by: Alexander Opitz
Reviewed-by: Sascha Egerer
Reviewed-by: Thomas Maroschik
Tested-by: Thomas Maroschik
Tested-by: Alexander Opitz
Reviewed-by: Ernesto Baschny
Tested-by: Ernesto Baschny

History
#1 - 2013-04-07 12:21 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#2 - 2013-04-08 08:31 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19604

#3 - 2013-04-08 09:23 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#4 - 2013-04-08 18:17 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#5 - 2013-04-08 19:17 - Gerrit Code Review
Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19601

#6 - 2013-04-08 19:17 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#7 - 2013-04-13 19:33 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#8 - 2013-04-14 00:33 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#9 - 2013-05-02 20:34 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#10 - 2013-05-02 20:47 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#11 - 2013-05-04 14:01 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#12 - 2013-05-04 17:31 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#13 - 2013-07-09 07:49 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#14 - 2013-07-15 21:18 - Gerrit Code Review
Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#15 - 2013-07-15 21:26 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#16 - 2013-07-15 22:24 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#17 - 2013-07-15 22:28 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#18 - 2013-08-06 11:37 - Gerrit Code Review

Patch set 18 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#19 - 2013-08-16 12:54 - Gerrit Code Review

Patch set 19 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#20 - 2013-08-16 14:55 - Alexander Opitz

After checkout the Patch Set, I got following Error in logfile:

[Fri Aug 16 14:04:28 2013] [error] [client 192.168.8.146] PHP Fatal error:  Uncaught exception
'TYPO3\\CMS\\Core\\Package\\Exception\\PackageStatesUnavailableException' with message
'The package states file is not available. Please visit the installer.' in
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/PackageManager.php:202
Stack trace:
#0 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/PackageManager.php(91):
TYPO3\\CMS\\Core\\Package\\PackageManager->loadPackageStates()
#1 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Core/Bootstrap.php(292):
TYPO3\\CMS\\Core\\Package\\PackageManager->initialize(Object(TYPO3\\CMS\\Core\\Core\\Bootstrap), '/home/opitz/web...')
#2 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Core/Bootstrap.php(224):
TYPO3\\CMS\\Core\\Core\\Bootstrap->initializePackageManagement('TYPO3\\CMS\\Core\\...')
#3 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/install/Start/Install.php(112):
TYPO3\\CMS\\Core\\Core\\Bootstrap->loadConfigurationAndInitialize(false, 'TYPO3\\CMS\\Core\\...') in
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/PackageManager.php on line 202
So I tried the installer and got following error

[Fri Aug 16 14:11:46 2013] [error] [client 192.168.8.146] PHP Fatal error:  Class 'TYPO3\\CMS\\Core\\Package\\FailSafePackageManager' not
found in /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Core/Bootstrap.php on line 286
[Fri Aug 16 14:11:46 2013] [error] [client 192.168.8.146] PHP Stack trace:
[Fri Aug 16 14:11:46 2013] [error] [client 192.168.8.146] PHP   1. {main}()
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/install/Start/Install.php:0
[Fri Aug 16 14:11:46 2013] [error] [client 192.168.8.146] PHP   2. TYPO3\\CMS\\Core\\Core\\Bootstrap->loadConfigurationAndInitialize()
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/install/Start/Install.php:112
[Fri Aug 16 14:11:46 2013] [error] [client 192.168.8.146] PHP   3. TYPO3\\CMS\\Core\\Core\\Bootstrap->initializePackageManagement()
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Core/Bootstrap.php:223

This is caused by the file name FailsafePackageManager.php vs class name FailSafePackageManager (upper vs lower case of the s in safe). After
renaming this class I got following error:

Fri Aug 16 14:35:26 2013] [error] [client 192.168.8.146] PHP Fatal error:  Uncaught exception
'TYPO3\\Flow\\Package\\Exception\\InvalidPackageKeyException' with message 
'"" is not a valid package key.' in
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/Package.php:103
Stack trace:
#0 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/PackageFactory.php(68):
TYPO3\\Flow\\Package\\Package->__construct(Object(TYPO3\\CMS\\Core\\Package\\FailSafePackageManager), '', '/home/opitz/web...',
'Classes/', '')
#1
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/PackageManager.php(794): TYPO3\\CMS\\Core\\Package\\PackageFactory->create('/home/opitz/web...', 'typo3conf/ext/m...', '', 'Classes/', '')
#2 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/FailSafePackageManager.php(81): TYPO3\\Flow\\Package\\PackageManager->registerPackagesFromConfiguration()
#3 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Pack in /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/Package.php on line 103

.php(794): TYPO3\\CMS\\Core\\Package\\PackageFactory->create('/home/opitz/web...', 'typo3conf/ext/m...', '', 'Classes/', '')
#2 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Package/FailSafePackageManager.php(81):
TYPO3\\Flow\\Package\\PackageManager->registerPackagesFromConfiguration()
#3 /home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Classes/Pack in
/home/opitz/projects/typo3-master/typo3-src/typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/Package.php on
line 103

This was caused by the new media management extension, which was installed, it includes something from behat which has no extension key.

#21 - 2013-08-16 19:58 - Gerrit Code Review

Patch set 20 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#22 - 2013-09-20 14:20 - Alexander Opitz

An issue in PHP that was fixed with todays version 5.4.20 "class_alias() should accept classes with leading backslashes" 
https://bugs.php.net/bug.php?id=61759

#23 - 2013-09-26 20:44 - Gerrit Code Review

Patch set 21 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605
#24 - 2013-10-11 10:25 - Gerrit Code Review

Patch set 22 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#25 - 2013-10-11 21:28 - Gerrit Code Review

Patch set 23 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#26 - 2013-10-12 12:12 - Gerrit Code Review

Patch set 24 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#27 - 2013-10-12 16:35 - Gerrit Code Review

Patch set 25 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#28 - 2013-10-12 16:46 - Gerrit Code Review

Patch set 26 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#29 - 2013-10-12 21:56 - Gerrit Code Review

Patch set 27 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#30 - 2013-10-13 00:00 - Gerrit Code Review

Patch set 28 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#31 - 2013-10-13 01:22 - Gerrit Code Review

Patch set 29 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#32 - 2013-10-13 02:52 - Gerrit Code Review

Patch set 30 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605
#33 - 2013-10-13 12:47 - Gerrit Code Review

Patch set 31 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19605

#34 - 2013-10-13 15:30 - Thomas Maroschik
- Status changed from Under Review to Resolved

Applied in changeset commit:84d6207c827ecba09dd7f357ca02369de569c12a.

#35 - 2014-02-12 09:48 - Ernesto Baschny
- Tracker changed from Feature to Epic
